<?php

/**
 * Controller is the customized base controller class.
 * All controller classes for this application should extend from this base class.
 */
class Controller extends CController {

    /**
     * @var string the default layout for the controller view. Defaults to '//layouts/column1',
     * meaning using a single column layout. See 'protected/views/layouts/column1.php'.
     */
    public $layout = '//layouts/column1';

    /**
     * @var array context menu items. This property will be assigned to {@link CMenu::items}.
     */
    public $menu = array();

    /**
     * @var array the breadcrumbs of the current page. The value of this property will
     * be assigned to {@link CBreadcrumbs::links}. Please refer to {@link CBreadcrumbs::links}
     * for more details on how to specify this property.
     */
    public $breadcrumbs = array();
    
    public function success($data){
        $array = array(
            'status'=>'OK',
            'data'=>$data,
        );
        
        $this->toJSON($array);
    }
    
    public function error($msg){
        $array = array(
            'status'=>'ERROR',
            'data'=>$msg,
        );
        
        $this->toJSON($array);
    }
    
    public function toJSON($data){
        echo CJSON::encode($data);
        Yii::app()->end();
    }
    
    public function expandErrors($model){
        $errors = $model->getErrors();
        $data = array();
        foreach($errors as $error){
            $data[] = $error[0];
        }
        $this->error($data);
    }

}