<?php

class HostController extends Controller {

    /**
     * Lists all models.
     */
//    public function actionList($start) {
//        $rowcount = Yii::app()->params['rowcount'];
//        $columncount = Yii::app()->params['columncount'];
//        
//        $criteria = new CDbCriteria();
//        $criteria->limit = ($rowcount*$columncount);
//        $criteria->offset = $start;
//        $criteria->order = 'hostid';
//        
//        $count = Host::model()->count();
//                
//        $models = Host::model()->findAll($criteria);
//        $this->success(array(
//            'data'=>$models,
//            'count'=>$count,
//        ));
//    }

    public function actionList() {
        $models = Host::model()->findAll();
        $this->success($models);
    }

    public function loadModel($id) {
        $model = Host::model()->findByPk($id);
        if ($model === null)
            $this->error('The requested page does not exist.');

        return $model;
    }

    public function actionView($id) {
        $model = $this->loadModel($id);
        $bill = Bill::model()->getBillByHostID($model->hostid);
        if ($bill != null) {
            $model->billno = $bill->billno;
        }

        $safeAttributes = $model->getAttributes($model->safeAttributeNames);

        $this->success($safeAttributes);
    }

    public function actionStatus($hostid) {
        $model = $this->loadModel($hostid);
        $bill = Bill::model()->getBillByHostID($model->hostid);
        if ($bill != null) {
            $model->billno = $bill->billno;
        }

        $data = array(
            'hoststatuscode' => $model->hoststatuscode,
            'billno' => $model->billno
        );
        $this->success($data);
    }

    public function actionKosong() {
        $criteria = new CDbCriteria();
        $criteria->compare('hoststatuscode', 'KSNG');
        $criteria->order = 'hostid';

        $models = Host::model()->findAll($criteria);
        $count = Host::model()->count($criteria);
        
        $this->success(array(
            'data' => $models,
            'count' => $count,
        ));
    }

}
