<?php

class SoController extends Controller {

    public function actionOrder() {
        $model = new So();
        if (isset($_POST['So']) && isset($_POST['Sod'])) {
            $model->attributes = $_POST['So'];

            $valid = true;
            $count = count($_POST['Sod']);
            $sods = array();
            for ($i = 0; $i < $count; $i++) {
                if (isset($_POST['Sod'][$i])) {
                    $sod = new Sod();
                    $sod->attributes = $_POST['Sod'][$i];
                    $sods[] = $sod;

                    $valid = $sod->validate() && $valid;
                }
            }

            $transaction = Yii::app()->db->beginTransaction();
            try {
                if ($valid && $model->save()) {
                    $i = 1;
                    foreach ($sods as $sod) {
                        $sod->sono = $model->sono;
                        $sod->sodno = $i;
                        $sod->save();
                        $i++;
                    }

                    $model->calcSum();

                    $model->spSo_New();

                    $transaction->commit();
                    $this->success(array('OK'));
                } else {
                    $this->expandErrors($model);
                }
            } catch (Exception $ex) {
                $transaction->rollback();
                $this->error($ex->getMessage());
            }
        }

//        $this->render('order', array(
//            'model' => $model,
//        ));
    }

    public function actionCancel($billno) {
        $model = Bill::model()->findByPk($billno);
        if ($model != null) {
            if (isset($_POST['Sod'])) {
                
                $valid = true;
                $count = count($_POST['Sod']);
                $sods = array();
                for ($i = 0; $i < $count; $i++) {
                    if (isset($_POST['Sod'][$i])) {
                        $sod = new Sod();
                        $sod->attributes = $_POST['Sod'][$i];
                        $sods[] = $sod;

                        $valid = $sod->validate() && $valid;
                    }
                }

                $transaction = Yii::app()->db->beginTransaction();
                try {
                    if ($valid) {
                        $i = 1;
                        $sono = '';
                        foreach ($sods as $sod) {
                            if($sono!=$sod->sono){
                                Sod::model()->deleteAllByAttributes(array('sono'=>$sod->sono));
                                $sono = $sod->sono;
                            }
                            
                            $sod->sodno = $i;
                            $sod->save();
                            $i++;
                        }

                        $model->spBillOrder_Cancel();

                        $transaction->commit();
                        $this->success(array('OK'));
                    } else {
                        $this->expandErrors($model);
                    }
                } catch (Exception $ex) {
                    $transaction->rollback();
                    $this->error($ex->getMessage());
                }
            }
        } 
//        else 
//            $this->error('The requested page does not exist.');
        
        $this->render('cancel', array(
            'model' => $model,
        ));
    }

    public function actionSod() {
//        $sod = new Sod();
//        $sod->sono = 'SO00002014';
//        $sod->sodno = 1;
//        $sod->itemid = '001037';
//        $sod->itemdesc = '1 Ptng Bebek Ptri Mdra';
//        $sod->qty = '1';
//        $sod->unit = 'PCS';
//        $sod->ispacked = false;
//        $sod->sodnote = '';
//        $sod->save();        
//        $sods = Sod::model()->findAllByAttributes(array('sono'=>'SO00002009'));
//        foreach($sods as $sod)
//            echo $sod->ispacked;
    }

    public function actionTax() {
//        echo BHelp::EvalDiscExp(15000, '15%+10%');
    }

}
